<?php

namespace chippyash\Test\Authentication\Manager\Encoder;

use Chippyash\Authentication\Manager\Encoder\BasicEncoder;
use Chippyash\Type\String\StringType;

/**
 * Generated by PHPUnit_SkeletonGenerator on 2014-12-19 at 06:29:26.
 */
class BasicEncoderTest extends \PHPUnit_Framework_TestCase
{

    /**
     * @var BasicEncoder
     */
    protected $object;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp()
    {
        $this->object = new BasicEncoder();
    }

    /**
     * @expectedException Chippyash\Authentication\Manager\Exceptions\AuthManagerException
     * @expectedExceptionMessage No Realm set
     */
    public function testCannotEncodeWithoutSettingRealmFirst()
    {
        $this->object->encode(new StringType('uid'), new StringType('pwd'));
    }

    public function testCanEncodeIfYouSetRealmFirst()
    {
        $digest = $this->object->setRealm(new StringType('realm'))
                ->encode(new StringType('uid'), new StringType('pwd'));
        $this->assertInstanceOf('Chippyash\Type\String\StringType', $digest);
    }

    public function testEncodingCreatesBasicDigest()
    {
        $expected = 'uid:realm:' . md5('uid:realm:pwd');
        $digest = $this->object->setRealm(new StringType('realm'))
                ->encode(new StringType('uid'), new StringType('pwd'));
        $this->assertEquals($expected, $digest());
    }

}
